routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();

Route::get('/', "PagesController@homepage");

Route::get('apply', "PagesController@apply")->name('apply')->middleware('auth');
Route::post('apply', "PagesController@postApply")->name('apply')->middleware('auth');

Route::resource('applications', 'App\\ApplicationsController');

app/Models/Application.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Application extends Model
{
    protected $guarded = [];
    
}

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Notifications\Notifiable;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];
}

app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];
}

app/Http/Controllers/App/ApplicationsController.php
<?php

namespace App\Http\Controllers\App;

use App\Http\Controllers\Controller;
use App\Models\Application;
use Illuminate\Http\Request;

class ApplicationsController extends Controller
{

    public function __construct()
    {
        // Accessible only to admins
    }

    /**
     * @param Request $request
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function index(Request $request)
    {
        if ($request->expectsJson())
            return Application::paginate(20);

        return view('applications.index');
    }



    /**
     * @param Application $application
     */
    public function accept(Application $application)
    {
        $application->accept();
    }

}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('home');
    }
}

app/Http/Controllers/PagesController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class PagesController extends Controller
{
    public function homepage() {
        return view('home');
    }

    public function apply() {
        return view('apply');
    }

    public function postApply() {

    }
}

resources/views/applications/complete.blade.php
@extends('layouts.main')

@section('content')
    <div id="contact">
        <div class="section-content">
            <h1 class="section-header">Grazie per la tua candidatura  <span class="content-header wow fadeIn " data-wow-delay="0.2s" data-wow-duration="2s"> {{$application->developer_first_name}}</span></h1>
            <h3>Riceverai presto una mail di risposta</h3>
        </div>

        <div class="contact-section">
            <div class="container">
                <a class="btn btn-default home-button submit" href="{{route('applications.create')}}">Torna alla home</a>
            </div>
        </div>
    </div>
@stop

resources/views/applications/index.blade.php
@extends('layouts.app')

@section('content')

    <applications inline-template>
        <div>
            <table>
                <tr v-for="(application, index) in items" :key="application.id">
                    <td>@{{ application.first_name }}</td>
                    <td>@{{ application.last_name }}</td>
                    <td><a href="javascript:;" onclick="accept(application)">{{__("Approve")}}</a></td>
                    <td><a href="javascript:;" onclick="">{{__("Refuse")}}</a></td>
                </tr>
            </table>

            <paginator :dataSet="dataSet" @changed="fetch"></paginator>
        </div>
    </applications>


@endsection

resources/views/apply.blade.php
@extends('layouts.app')

@section('content')
    <section class="px-3 py-3 pt-md-5 pb-md-4 mx-auto text-center">
        <img src="//bitboss.it/images/BitBoss/logo-black-200.png"/>
        <div class="container">
            <h1>Candidati</h1>
            <p class="lead">Presenta la tua candidatura</p>
        </div>
    </section>
    <section>
        <div class="container">
            <div class="container">
                {!! Form::open(['route' => ['applications.store'], 'method' => 'post'])!!}
                <div class="form-group">
                    {!! Form::label('first_name', 'Nome') !!}
                    {!! Form::text('first_name', null, ['class' => 'form-control', 'placeholder'=>'Nome']) !!}
                </div>

                <div class="form-group">
                    {!! Form::label('last_name', 'Cognome') !!}
                    {!! Form::text('last_name', null, ['class' => 'form-control', 'placeholder'=>'Cognome']) !!}
                </div>

                <div class="form-group">
                    {!! Form::label('email', 'Email') !!}
                    {!! Form::text('email', null, ['class' => 'form-control', 'placeholder'=>'Email']) !!}
                </div>

                <div class="form-group">
                    {!! Form::label('phone', 'Telefono') !!}
                    {!! Form::text('phone', null, ['class' => 'form-control', 'placeholder'=>'Telefono']) !!}
                </div>

                <div class="form-group">
                    {!! Form::label('notes', 'Note') !!}
                    {!! Form::textarea('notes', null, ['rows'=>3, 'class' => 'form-control', 'placeholder'=>'Note']) !!}
                </div>

                <div>

                    <button type="submit" class="btn btn-lg btn-block btn-outline-primary"><i class="fa fa-paper-plane"
                                                                                              aria-hidden="true"></i>
                        {{__("Invia candidatura")}}
                    </button>
                </div>

                {!! Form::close() !!}
            </div>
    </section>

@stop

resources/views/home.blade.php
@extends('layouts.app')

@section('content')
    <section class="jumbotron text-center">
        <div class="container">
            <h1 class="jumbotron-heading">Benvenuto</h1>
            <p class="lead text-muted">Candidati ora per diventare uno sviluppatore di BitBoss</p>
            <p>
                <a href="{{route('apply')}}" class="btn btn-primary my-2">Candidati</a>
            </p>
        </div>
    </section>
    <section class="">
        <div class="container">
            <h2>Il Test</h2>

            <p>Abbiamo costruito questo test.</p>

            <p>Abbiamo fatto finta di creare questa piccola - e brutta - applicazione per raccogliere le candidature dei
                programmatori. Riesci a finirla? </p>

            <p>Non ti preoccupare, non la useremo davvero per raccogliere candidature. Siamo più bravi di così.</p>

            <h2>Requisiti</h2>
            <ul>
                <li> Mettere il footer sticky in fondo alla pagina
                </li>
                <li>Dopo la registrazione, l'utente deve finire sulla pagina per candidarsi.</li>
                <li> Memorizzare la candidatura dell'utente
                </li>
                <li> Associare la candidatura all'utente che l'ha inviata
                </li>
                <li> Dare all'utente la possibilità di accedere ad una pagina dove è presente lo stato
                    della sua candidatura (accettata o rifiutata). Al login l'utente viene portato automaticamente su
                    questa pagina.
                </li>
                <li>Un utente non può candidarsi più volte</li>
                <li> Solo gli utenti admin possono accedere alla manipolazione delle candidature
                </li>
                <li> Notifica quando c’è una nuova candidatura (su Slack + Email agli utenti admin)
                </li>
                <li> Logica di accettazione o scarto dopo che admin ha cliccato sul pulsante
                </li>
                <li> Notifica al candidato quando viene accettato o rifiutato
                </li>
                <li> Popolare il database con un seed delle candidature
                </li>
            </ul>
            <h2>Quando hai finito</h2>
            <p>Fai il push sul repository. Esamineremo il codice che hai scritto.</p>
            <h2>Cosa esamineremo</h2>
            <p>Guarderemo se il codice funziona e se i requisiti sono rispettati, certo.</p>
            <p>Ma guarderemo anche tutto il resto: la qualità e l'ordine del codice, l'inventiva per risolvere un
                problema, quanto conosci Laravel, le ottimizzazioni e i piccoli dettagli.</p>
            <p>Non aver paura di usare troppo overengineering, di stravolgere tutto, o, al contrario, di usare la nostra traccia, o di essere troppo banale. Prova - se ti va
                - a
                stupirci.</p>
        </div>
    </section>
@endsection

resources/views/layouts/app.blade.php
<!DOCTYPE html>
<html lang="{{ app()->getLocale() }}">
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}" defer></script>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="https://fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css?family=Raleway:300,400,600" rel="stylesheet" type="text/css">

    <!-- Styles -->
    <link href="{{ asset('css/app.css') }}" rel="stylesheet">
</head>
<body>
    <div id="app">
        <nav class="navbar navbar-expand-md navbar-light navbar-laravel">
            <div class="container">
                <a class="navbar-brand" href="{{ url('/') }}">
                    {{ config('app.name', 'Laravel') }}
                </a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>

                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <!-- Left Side Of Navbar -->
                    <ul class="navbar-nav mr-auto">

                    </ul>

                    <!-- Right Side Of Navbar -->
                    <ul class="navbar-nav ml-auto">
                        <!-- Authentication Links -->
                        @guest
                            <li><a class="nav-link" href="{{ route('login') }}">{{ __('Login') }}</a></li>
                            <li><a class="nav-link" href="{{ route('register') }}">{{ __('Register') }}</a></li>
                        @else
                            <li class="nav-item dropdown">
                                <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                    {{ Auth::user()->name }} <span class="caret"></span>
                                </a>

                                <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                                    <a class="dropdown-item" href="{{ route('logout') }}"
                                       onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                        {{ __('Logout') }}
                                    </a>

                                    <form id="logout-form" action="{{ route('logout') }}" method="POST" style="display: none;">
                                        @csrf
                                    </form>
                                </div>
                            </li>
                        @endguest
                    </ul>
                </div>
            </div>
        </nav>

        <main class="">
            @yield('content')
        </main>
        <footer class="footer">
            <div class="container">
                <span class="text-muted">In bocca al lupo! © BitBoss srl</span>
            </div>
        </footer>

    </div>
</body>
</html>

resources/views/layouts/main.blade.php
<!DOCTYPE html>

<html lang="en">

<head>

    <meta charset="utf-8"/>
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta content="width=device-width, initial-scale=1" name="viewport"/>
    <meta content=""
          name="description"/>
    <meta content="BitBossTest" name="author"/>
    <!-- BEGIN GLOBAL MANDATORY STYLES -->

    <title>{{ config('app.name', 'BitBossTest') }}</title>

    <meta name="csrf-token" content="{{ csrf_token() }}">


    <link href="https://fonts.googleapis.com/css?family=Poppins:400,300,600,700&subset=all" rel="stylesheet"
          type="text/css"/>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">

    <link href="{{asset("/css/app.css")}}" rel="stylesheet">

    <link rel="shortcut icon" href="favicon.ico"/>
    <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
</head>

<body>
    <div id="app">
        @yield('content')
    </div>


    <script src="{{ asset('js/app.js') }}"></script>
</body>

</html>

resources/views/situation.blade.php
@extends('layouts.app')

@section('content')
    <section class="px-3 py-3 pt-md-5 pb-md-4 mx-auto text-center">
        <div class="container">
            <h1>Candidatura</h1>
        </div>
    </section>
    <section>
        {{__("Your application is ") }} {{--Refused / Accepted at date ...--}}
    </section>
@stop